A high-performance general-purpose compute library

- Main Page
- Tutorials
- Release Notes
- Examples

Functions
max
ArrayFire Functions | ArrayFire Functions by Category » Vector Algorithms » Reduction operations

## Functions
AFAPI array | max (const array &in, const int dim=-1)
| C++ Interface to return the maximum along a given dimension.
AFAPI void | max (array &val, array &idx, const array &in, const array &ragged_len, const int dim)
| C++ Interface to return the ragged maximum along a given dimension.
template<typename T >
T | max (const array &in)
| C++ Interface to return the maximum along the first non-singleton dimension.
AFAPI void | max (array &val, array &idx, const array &in, const int dim=-1)
| C++ Interface to return the maximum and its location along a given dimension.
template<typename T >
void | max (T *val, unsigned *idx, const array &in)
| C++ Interface to return the maximum and its location over all dimensions.
AFAPI af_err | af_max (af_array *out, const af_array in, const int dim)
| C Interface to return the maximum along a given dimension.
AFAPI af_err | af_max_ragged (af_array *val, af_array *idx, const af_array in, const af_array ragged_len, const int dim)
| C Interface to return the ragged maximum over a given dimension.
AFAPI af_err | af_max_all (double *real, double *imag, const af_array in)
| C Interface to return the maximum over all dimensions.
AFAPI af_err | af_max_all_array (af_array *out, const af_array in)
| C Interface to return the maximum over all dimensions.
AFAPI af_err | af_imax (af_array *out, af_array *idx, const af_array in, const int dim)
| C Interface to return the maximum and its location along a given dimension.
AFAPI af_err | af_imax_all (double *real, double *imag, unsigned *idx, const af_array in)
| C Interface to return the maximum and its location over all dimensions.

## Detailed Description

Return the maximum along a given dimension.

This function runs across all batches in the input simultaneously.

## Function Documentation

## ◆ af_imax()

AFAPI af_err af_imax | ( | af_array * | out,
|  | af_array * | idx,
|  | const af_array | in,
|  | const int | dim )

C Interface to return the maximum and its location along a given dimension.

Parameters

  [out] | out | maximum
  [out] | idx | location
  [in] | in | input array
  [in] | dim | dimension along which the maximum is found

Returns
  AF_SUCCESS, if function returns successfully, else an af_err code is given

## ◆ af_imax_all()

AFAPI af_err af_imax_all | ( | double * | real,
|  | double * | imag,
|  | unsigned * | idx,
|  | const af_array | in )

C Interface to return the maximum and its location over all dimensions.

NaN values are ignored.

Parameters

  [out] | real | real component of the maximum
  [out] | imag | imaginary component of the maximum; 0 if `idx` is real
  [out] | idx | location
  [in] | in | input array

Returns
  AF_SUCCESS, if function returns successfully, else an af_err code is given

## ◆ af_max()

AFAPI af_err af_max | ( | af_array * | out,
|  | const af_array | in,
|  | const int | dim )

C Interface to return the maximum along a given dimension.

Parameters

  [out] | out | maximum
  [in] | in | input array
  [in] | dim | dimension along which the maximum is found

Returns
  AF_SUCCESS, if function returns successfully, else an af_err code is given

## ◆ af_max_all()

AFAPI af_err af_max_all | ( | double * | real,
|  | double * | imag,
|  | const af_array | in )

C Interface to return the maximum over all dimensions.

If `in` is real, `imag` will be set to zeros.

Parameters

  [out] | real | real component of the maximum
  [out] | imag | imaginary component of the maximum
  [in] | in | input array

Returns
  AF_SUCCESS, if function returns successfully, else an af_err code is given

## ◆ af_max_all_array()

AFAPI af_err af_max_all_array | ( | af_array * | out,
|  | const af_array | in )

C Interface to return the maximum over all dimensions.

Parameters

  [out] | out | maximum
  [in] | in | input array

Returns
  AF_SUCCESS, if function returns successfully, else an af_err code is given

## ◆ af_max_ragged()

AFAPI af_err af_max_ragged | ( | af_array * | val,
|  | af_array * | idx,
|  | const af_array | in,
|  | const af_array | ragged_len,
|  | const int | dim )

C Interface to return the ragged maximum over a given dimension.

Input parameter `ragged_len` sets the number of elements to consider.

NaN values are ignored.

Parameters

  [out] | val | ragged maximum
  [out] | idx | locations of the maximum ragged values
  [in] | in | input array
  [in] | ragged_len | array containing the number of elements to use
  [in] | dim | dimension along which the maximum is found

Returns
  AF_SUCCESS, if function returns successfully, else an af_err code is given

## ◆ max() [1/5]

AFAPI void max | ( | array & | val,
|  | array & | idx,
|  | const array & | in,
|  | const array & | ragged_len,
|  | const int | dim )

C++ Interface to return the ragged maximum along a given dimension.

Input parameter `ragged_len` sets the number of elements to consider.

NaN values are ignored.

Parameters

  [out] | val | ragged maximum
  [out] | idx | locations of the maximum ragged values
  [in] | in | input array
  [in] | ragged_len | array containing the number of elements to use
  [in] | dim | dimension along which the maximum is found

## ◆ max() [2/5]

AFAPI void max | ( | array & | val,
|  | array & | idx,
|  | const array & | in,
|  | const int | dim = -1 )

C++ Interface to return the maximum and its location along a given dimension.

NaN values are ignored.

Parameters

  [out] | val | maximum
  [out] | idx | location
  [in] | in | input array
  [in] | dim | dimension along which the maximum is found, -1 denotes the first non-singleton dimension

## ◆ max() [3/5]

template<typename T >

T max | ( | const array & | in | ) |

C++ Interface to return the maximum along the first non-singleton dimension.

NaN values are ignored.

Parameters

  [in] | in | input array

Returns
  maximum

## ◆ max() [4/5]

AFAPI array max | ( | const array & | in,
|  | const int | dim = -1 )

C++ Interface to return the maximum along a given dimension.

NaN values are ignored.

Parameters

  [in] | in | input array
  [in] | dim | dimension along which the maximum is found, -1 denotes the first non-singleton dimension

Returns
  maximum

Examples
  computer_vision/matching.cpp, financial/heston_model.cpp, graphics/fractal.cpp, graphics/gravity_sim.cpp, image_processing/binary_thresholding.cpp, image_processing/confidence_connected_components.cpp, image_processing/filters.cpp, and image_processing/image_editing.cpp.

## ◆ max() [5/5]

template<typename T >

void max | ( | T * | val,
|  | unsigned * | idx,
|  | const array & | in )

C++ Interface to return the maximum and its location over all dimensions.

NaN values are ignored.

Often used to return values directly to the host.

Parameters

  [out] | val | maximum
  [out] | idx | location
  [in] | in | input array